From 925a81284bb37bfdf345317bc63003f71c0fcc9e Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Wed, 17 Dec 2014 13:26:16 +0100
Subject: [PATCH 1/2] sbus: use hard coded getters instead of generated

Properties are single value of a small number of predefined D-Bus
types. There is no need to generate them with codegen. Actually,
the source generator for property getters is already quite mess
with branching for array, strings and object paths. Adding any
more complex type in the future (such as dictionary) would require
even more branching or creating a separate path for it.

Hard coding the getters will simplify creating new ones for more
complex types. This patch also reduces lots of code duplication
and creates a simple function for GetAll.
---
 Makefile.am                                   |   2 +
 src/monitor/monitor_iface_generated.c         |  57 +-
 src/providers/data_provider_iface_generated.c |  57 +-
 src/responder/ifp/ifp_iface_generated.c       | 443 +--------------
 src/sbus/sbus_codegen                         | 133 +----
 src/sbus/sssd_dbus_invokers.c                 | 424 ++++++++++++++
 src/sbus/sssd_dbus_invokers.h                 | 120 ++++
 src/sbus/sssd_dbus_meta.h                     |  15 +-
 src/sbus/sssd_dbus_properties.c               |  51 +-
 src/tests/sbus_codegen_tests_generated.c      | 789 +-------------------------
 10 files changed, 654 insertions(+), 1437 deletions(-)
 create mode 100644 src/sbus/sssd_dbus_invokers.c
 create mode 100644 src/sbus/sssd_dbus_invokers.h

diff --git a/Makefile.am b/Makefile.am
index d5ce6109f06608eac0b632c92683890e3e3877d5..cd8ab4d733fd122d382a04c08df574157350e4fc 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -521,6 +521,7 @@ dist_noinst_HEADERS = \
     src/sbus/sssd_dbus.h \
     src/sbus/sssd_dbus_meta.h \
     src/sbus/sssd_dbus_private.h \
+    src/sbus/sssd_dbus_invokers.h \
     src/db/sysdb.h \
     src/db/sysdb_sudo.h \
     src/db/sysdb_autofs.h \
@@ -709,6 +710,7 @@ libsss_util_la_SOURCES = \
     src/sbus/sssd_dbus_meta.c \
     src/sbus/sssd_dbus_interface.c \
     src/sbus/sssd_dbus_introspect.c \
+    src/sbus/sssd_dbus_invokers.c \
     src/sbus/sssd_dbus_properties.c \
     src/sbus/sssd_dbus_request.c \
     src/sbus/sssd_dbus_server.c \
diff --git a/src/monitor/monitor_iface_generated.c b/src/monitor/monitor_iface_generated.c
index 0eee10caefdf137e442e7c658436813d01025035..171cef7e65a0241d8a8b60e5476a8691c8ed3fb3 100644
--- a/src/monitor/monitor_iface_generated.c
+++ b/src/monitor/monitor_iface_generated.c
@@ -3,6 +3,7 @@
 #include "util/util.h"
 #include "sbus/sssd_dbus.h"
 #include "sbus/sssd_dbus_meta.h"
+#include "sbus/sssd_dbus_invokers.h"
 #include "monitor_iface_generated.h"
 
 /* methods for org.freedesktop.sssd.monitor */
@@ -24,39 +25,13 @@ const struct sbus_method_meta mon_srv_iface__methods[] = {
     { NULL, }
 };
 
-/* invokes GetAll for the 'org.freedesktop.sssd.monitor' interface */
-static int invoke_mon_srv_iface_get_all(struct sbus_request *dbus_req, void *function_ptr)
-{
-    DBusMessage *reply;
-    dbus_bool_t dbret;
-    DBusMessageIter iter;
-    DBusMessageIter iter_dict;
-
-    reply = dbus_message_new_method_return(dbus_req->message);
-    if (!reply) return ENOMEM;
-    dbus_message_iter_init_append(reply, &iter);
-    dbret = dbus_message_iter_open_container(
-                                     &iter, DBUS_TYPE_ARRAY,
-                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING
-                                     DBUS_TYPE_STRING_AS_STRING
-                                     DBUS_TYPE_VARIANT_AS_STRING
-                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,
-                                     &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    dbret = dbus_message_iter_close_container(&iter, &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    return sbus_request_finish(dbus_req, reply);
-}
-
 /* interface info for org.freedesktop.sssd.monitor */
 const struct sbus_interface_meta mon_srv_iface_meta = {
     "org.freedesktop.sssd.monitor", /* name */
     mon_srv_iface__methods,
     NULL, /* no signals */
     NULL, /* no properties */
-    invoke_mon_srv_iface_get_all, /* GetAll invoker */
+    sbus_invoke_get_all, /* GetAll invoker */
 };
 
 /* methods for org.freedesktop.sssd.service */
@@ -127,37 +102,11 @@ const struct sbus_method_meta mon_cli_iface__methods[] = {
     { NULL, }
 };
 
-/* invokes GetAll for the 'org.freedesktop.sssd.service' interface */
-static int invoke_mon_cli_iface_get_all(struct sbus_request *dbus_req, void *function_ptr)
-{
-    DBusMessage *reply;
-    dbus_bool_t dbret;
-    DBusMessageIter iter;
-    DBusMessageIter iter_dict;
-
-    reply = dbus_message_new_method_return(dbus_req->message);
-    if (!reply) return ENOMEM;
-    dbus_message_iter_init_append(reply, &iter);
-    dbret = dbus_message_iter_open_container(
-                                     &iter, DBUS_TYPE_ARRAY,
-                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING
-                                     DBUS_TYPE_STRING_AS_STRING
-                                     DBUS_TYPE_VARIANT_AS_STRING
-                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,
-                                     &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    dbret = dbus_message_iter_close_container(&iter, &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    return sbus_request_finish(dbus_req, reply);
-}
-
 /* interface info for org.freedesktop.sssd.service */
 const struct sbus_interface_meta mon_cli_iface_meta = {
     "org.freedesktop.sssd.service", /* name */
     mon_cli_iface__methods,
     NULL, /* no signals */
     NULL, /* no properties */
-    invoke_mon_cli_iface_get_all, /* GetAll invoker */
+    sbus_invoke_get_all, /* GetAll invoker */
 };
diff --git a/src/providers/data_provider_iface_generated.c b/src/providers/data_provider_iface_generated.c
index 58813762570c12b17c26f8116ced347de540b263..bdd6a4d76d18bbb44530d816fce14009736b6f6d 100644
--- a/src/providers/data_provider_iface_generated.c
+++ b/src/providers/data_provider_iface_generated.c
@@ -3,6 +3,7 @@
 #include "util/util.h"
 #include "sbus/sssd_dbus.h"
 #include "sbus/sssd_dbus_meta.h"
+#include "sbus/sssd_dbus_invokers.h"
 #include "data_provider_iface_generated.h"
 
 /* methods for org.freedesktop.sssd.dataprovider */
@@ -59,39 +60,13 @@ const struct sbus_method_meta data_provider_iface__methods[] = {
     { NULL, }
 };
 
-/* invokes GetAll for the 'org.freedesktop.sssd.dataprovider' interface */
-static int invoke_data_provider_iface_get_all(struct sbus_request *dbus_req, void *function_ptr)
-{
-    DBusMessage *reply;
-    dbus_bool_t dbret;
-    DBusMessageIter iter;
-    DBusMessageIter iter_dict;
-
-    reply = dbus_message_new_method_return(dbus_req->message);
-    if (!reply) return ENOMEM;
-    dbus_message_iter_init_append(reply, &iter);
-    dbret = dbus_message_iter_open_container(
-                                     &iter, DBUS_TYPE_ARRAY,
-                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING
-                                     DBUS_TYPE_STRING_AS_STRING
-                                     DBUS_TYPE_VARIANT_AS_STRING
-                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,
-                                     &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    dbret = dbus_message_iter_close_container(&iter, &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    return sbus_request_finish(dbus_req, reply);
-}
-
 /* interface info for org.freedesktop.sssd.dataprovider */
 const struct sbus_interface_meta data_provider_iface_meta = {
     "org.freedesktop.sssd.dataprovider", /* name */
     data_provider_iface__methods,
     NULL, /* no signals */
     NULL, /* no properties */
-    invoke_data_provider_iface_get_all, /* GetAll invoker */
+    sbus_invoke_get_all, /* GetAll invoker */
 };
 
 /* methods for org.freedesktop.sssd.dataprovider_rev */
@@ -113,37 +88,11 @@ const struct sbus_method_meta data_provider_rev_iface__methods[] = {
     { NULL, }
 };
 
-/* invokes GetAll for the 'org.freedesktop.sssd.dataprovider_rev' interface */
-static int invoke_data_provider_rev_iface_get_all(struct sbus_request *dbus_req, void *function_ptr)
-{
-    DBusMessage *reply;
-    dbus_bool_t dbret;
-    DBusMessageIter iter;
-    DBusMessageIter iter_dict;
-
-    reply = dbus_message_new_method_return(dbus_req->message);
-    if (!reply) return ENOMEM;
-    dbus_message_iter_init_append(reply, &iter);
-    dbret = dbus_message_iter_open_container(
-                                     &iter, DBUS_TYPE_ARRAY,
-                                     DBUS_DICT_ENTRY_BEGIN_CHAR_AS_STRING
-                                     DBUS_TYPE_STRING_AS_STRING
-                                     DBUS_TYPE_VARIANT_AS_STRING
-                                     DBUS_DICT_ENTRY_END_CHAR_AS_STRING,
-                                     &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    dbret = dbus_message_iter_close_container(&iter, &iter_dict);
-    if (!dbret) return ENOMEM;
-
-    return sbus_request_finish(dbus_req, reply);
-}
-
 /* interface info for org.freedesktop.sssd.dataprovider_rev */
 const struct sbus_interface_meta data_provider_rev_iface_meta = {
     "org.freedesktop.sssd.dataprovider_rev", /* name */
     data_provider_rev_iface__methods,
     NULL, /* no signals */
     NULL, /* no properties */
-    invoke_data_provider_rev_iface_get_all, /* GetAll invoker */
+    sbus_invoke_get_all, /* GetAll invoker */
 };
